import errno
import subprocess
import pdb


def Communicate( s ):
    proc = subprocess.Popen( ['python', 'receiver.py'], stdin=subprocess.PIPE,
                             stdout=subprocess.PIPE, stderr=subprocess.PIPE )

    try:
        out, err = proc.communicate( s )
    except (IOError, OSError), e:
        # NOTE: On Microsoft Windows and FreeBSD, exception of different class is raised in case
        #       of broken pipe (IOError [32] on Windows and OSError [32] on FreeBSD).
        if e.errno == errno.EPIPE:
            proc.wait()
            out, err = proc.stdout.read(), proc.stderr.read()
        else:
            raise

    print "Return Code:     %s" % proc.returncode
    print "Standard Output: %s" % out
    print "Standard Error:  %s" % err


if __name__ == '__main__':
    Communicate( "abcd" + "x"*100000 )
    # NOTE: To test correctness of reproduction code, communicate something short, e.g. modify
    #       above line to: Communicate( "abcd" )
